<?php
/**
 * Static content controller.
 *
 * This file will render views from views/pages/
 *
 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 * @link          http://cakephp.org CakePHP(tm) Project
 * @package       app.Controller
 * @since         CakePHP(tm) v 0.2.9
 * @license       http://www.opensource.org/licenses/mit-license.php MIT License
 */

App::uses('AppController', 'Controller');

/**
 * Static content controller
 *
 * Override this controller by placing a copy in controllers directory of an application
 *
 * @package       app.Controller
 * @link http://book.cakephp.org/2.0/en/controllers/pages-controller.html
 */
class TimezonesController extends AppController {
/**
 * This controller uses the Timezone model
 *
 * @var array
 */
	public $uses = array('Timezone');
	public $helpers = array('Js');
	public $components = array('RequestHandler');
	
	public function beforeFilter() {
		parent::beforeFilter();

		// Change layout for Ajax requests
		if ($this->request->is('ajax')) {
			$this->layout = 'ajax';
		}
	}
	
	
	public function get_time() {
		// this function is just used to display the form
	}
	
	public function ajax_get_time() {
		$this->request->onlyAllow('ajax'); // No direct access via browser URL
		
		$content = '<div class="alert alert-warning" role="alert">Something unexpected occured</div>';
		
		if ($this->request->is('post')) {
			
			$this->Timezone->set($this->request->data);
			if($this->Timezone->validates()){
				$city = $this->request->data['Timezone']['city'];
				if (strcasecmp($city, "Montreal") == 0) {
					date_default_timezone_set('America/Toronto');
					$content = '<div class="alert alert-success" role="alert">The time in Montreal is : <strong>'.date('D M d Y - H:i:s ', time()).'</strong></div>';
				}else if (strcasecmp($city, "Mumbai") == 0) {
					date_default_timezone_set('Asia/Calcutta');
					$content = '<div class="alert alert-success" role="alert">The time in Mumbai is : <strong>'.date('D M d Y - H:i:s ', time()).'</strong></div>';
				}else if (strcasecmp($city, "New York") == 0) {
					date_default_timezone_set('America/New_York');
					$content = '<div class="alert alert-success" role="alert">The time in New York is : <strong>'.date('D M d Y - H:i:s ', time()).'</strong></div>';
				}else if (strcasecmp($city, "London") == 0) {
					date_default_timezone_set('Europe/London');
					$content = '<div class="alert alert-success" role="alert">The time in London is : <strong>'.date('D M d Y - H:i:s ', time()).'</strong></div>';
				}else if (strcasecmp($city, "Paris") == 0) {
					date_default_timezone_set('Europe/Paris');
					$content = '<div class="alert alert-success" role="alert">The time in Paris is : <strong>'.date('D M d Y - H:i:s ', time()).'</strong></div>';
				}else if (strcasecmp($city, "Sydney") == 0) {
					date_default_timezone_set('Australia/Sydney');
					$content = '<div class="alert alert-success" role="alert">The time in Sydney is : <strong>'.date('D M d Y - H:i:s ', time()).'</strong></div>';
				}else if (strcasecmp($city, "Toronto") == 0) {
					date_default_timezone_set('America/Toronto');
					$content = '<div class="alert alert-success" role="alert">The time in Toronto is : <strong>'.date('D M d Y - H:i:s ', time()).'</strong></div>';
				}else{
					$content = '<div class="alert alert-danger" role="alert">An Unexpected Error Occured </div>';
				}
			}else{
				$errors = $this->Timezone->validationErrors;
				$flatErrors = Set::flatten($errors);
				if(count($errors) > 0) { 
					$content = '<div class="alert alert-danger" role="alert">Could not get timezone. The following errors occurred: ';
					$content .= '<ul>';
					 foreach($flatErrors as $key => $value) {
						$content .= '<li><strong>'.$value.'</strong></li>';
					 }
					$content .= '</ul>';
					$content .= '</div>';
				}
			}

		}
		
		//set current date as content to show in view
		$this->set(compact('content')); 
	  
		//render spacial view for ajax
		$this->render('ajax_response', 'ajax');	

	}
}	
?>